# Poco::Net

# class HTTPServerRequest

Library: Net
Package: HTTPServer
Header: Poco/Net/HTTPServerRequest.h

## Description

This abstract subclass of HTTPRequest is used for representing server-side HTTP requests.

A HTTPServerRequest is passed to the handleRequest() method of HTTPRequestHandler.

## Inheritance

Direct Base Classes: HTTPRequest

All Base Classes: HTTPMessage, HTTPRequest, MessageHeader, NameValueCollection

Known Derived Classes: HTTPServerRequestImpl

## Member Summary

Member Functions: clientAddress, response, secure, serverAddress, serverParams, stream

Inherited Functions: add, begin, clear, decodeRFC2047, decodeWord, empty, end, erase, find, get, getChunkedTransferEncoding, getContentLength, getContentLength64, getContentType, getCookies, getCredentials, getExpectContinue, getFieldLimit, getHost, getKeepAlive, getMethod, getNameLengthLimit, getProxyCredentials, getTransferEncoding, getURI, getValueLengthLimit, getVersion, has, hasContentLength, hasCredentials, hasProxyCredentials, hasToken, operator =, operator [], quote, read, removeCredentials, removeProxyCredentials, set, setChunkedTransferEncoding, setContentLength, setContentLength64, setContentType, setCookies, setCredentials, setExpectContinue, setFieldLimit, setHost, setKeepAlive, setMethod, setNameLengthLimit, setProxyCredentials, setTransferEncoding, setURI, setValueLengthLimit, setVersion, size, splitElements, splitParameters, swap, write

## Constructors

### HTTPServerRequest

HTTPServerRequest();

Creates the HTTPServerRequest

## Destructor

### ~HTTPServerRequest

~HTTPServerRequest();

Destroys the HTTPServerRequest.

## Member Functions

### clientAddress

virtual const SocketAddress & clientAddress() const = 0;

Returns the client's address.

### response

virtual HTTPServerResponse & response() const = 0;

Returns a reference to the associated response.

### secure

virtual bool secure() const = 0;

Returns true if the request is using a secure connection. Returns false if no secure connection is used, or if it is not known whether a secure connection is used.

### serverAddress

virtual const SocketAddress & serverAddress() const = 0;

Returns the server's address.

### serverParams

virtual const HTTPServerParams & serverParams() const = 0;

Returns a reference to the server parameters.

### stream

virtual std::istream & stream() = 0;

Returns the input stream for reading the request body.

The stream must be valid until the HTTPServerRequest object is destroyed.